{ --------------------------------------------------------------------------- }
{ DRIVES.PAS  DrvTypes unit demonstration program.              Version 2.12  }
{                                                                             }
{ *** PUBLIC DOMAIN ***                                                       }
{ *** NO WARRANTIES PROVIDED AND AS-IS BASIS IS ASSUMED ***                   }
{                                                                             }
{ Written by Bobby Z. and Mr. Byte                                            }
{ --------------------------------------------------------------------------- }
{$S-,I-,R-}   { disable stack, I/O and range checking }
uses DrvTypes;

function FloppyDrives : Byte; assembler;
{ - returns number of floppy drives in system }
asm
        int     11h
        test    al,00000001b
        jz      @@1
{$IFOPT G+}
        shr     al,6
{$ELSE}
        mov     cl,6
        shr     al,cl
{$ENDIF}
        and     al,3
        inc     al
        jmp     @@Q
@@1:
        sub     al,al
@@Q:
end;

var C : Char;
    T : array[1..26] of Byte;
    D : Word;

procedure WriteDescription( C : Char; Desc : String );
 begin
  WriteLn('Drive ',C,': is ',Desc);
 end;

begin
 WriteLn('Drive Map  Version 2.12  Written by Mr. Byte and Bobby Z.'#13#10);
 asm
        mov     ah,30h
        int     21h
        mov     D,ax
 end;
 if Lo(D) < 4 then { DOS 4.0+ required }
  begin
   WriteLn('DOS version is ',Hi(D),'.',Lo(D),'!!! Where did you get this dinosaur?');
   WriteLn('I won''t work until you upgrade to at least v4.00...');
   Halt;
  end;
 for C := #1 to #26 do
  T[Byte(C)] := getDriveType(Byte(C));
 for C := 'A' to 'Z' do
  case T[Byte(C)-Byte('A')+1] of
   dtCDROM    : WriteDescription(C,'CD-ROM drive.');
   dtSUBST    : WriteDescription(C,'SUBST''ed drive.');
   dtRemote   : WriteDescription(C,'remote (network) drive.');
   dtFixed    : WriteDescription(C,'local hard drive.');
   dtRemovable:
       if (Byte(C)-Byte('A')+1) in [1..FloppyDrives] then
        WriteDescription(C,'removable (floppy) drive.')
       else
       if C > 'B' then
        WriteDescription(C,'removable (MO, SyQuest, etc.) drive.')
       else
        WriteDescription(C,'phantom floppy drive.');
   dtDblSpace : WriteDescription(C,'D*Space compressed drive.');
   dtStacker  : WriteDescription(C,'Stacker compressed drive.');
   dtRAMDrive : WriteDescription(C,'RAM drive.');
   dtDublDisk : WriteDescription(C,'Vertisoft DoubleDisk 2.6+ compressed drive.');
   dtBernoully: WriteDescription(C,'Bernoully drive.');
   dtDiskreet : WriteDescription(C,'Norton Diskreet protected drive.');
   dtSuperStor: WriteDescription(C,'SuperStor compressed drive.');
  end;
end.
